diff --git a/src/backend/commands/ddldeparse.c b/src/backend/commands/ddldeparse.c
index 5878d7e465..7165ead751 100644
--- a/src/backend/commands/ddldeparse.c
+++ b/src/backend/commands/ddldeparse.c
@@ -2448,354 +2369,322 @@ deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
 					def = (ColumnDef *) subcmd->def;
 					Assert(IsA(def, ColumnDef));
 
-					tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I SET DATA TYPE %{datatype}T", 3,
-											"type", ObjTypeString, "alter column type",
-											"column", ObjTypeString, subcmd->name,
-											"datatype", ObjTypeObject,
-											new_objtree_for_type(att->atttypid,
-																 att->atttypmod));
+					pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+					new_jsonb_VA(state,
+								 "ALTER COLUMN %{column}I SET DATA TYPE %{datatype}T %{collation}s %{using}s", true, 2,
+								 "type", jbvString, "alter column type",
+								 "column", jbvString, subcmd->name);
+
+					insert_jsonb_key(state, "datatype");
+
+					new_jsonb_for_type(state, att->atttypid, att->atttypmod);
 
 					/* Add a COLLATE clause, if needed */
-					tmp_obj2 = new_objtree("COLLATE");
+					insert_jsonb_key(state, "collation");
 					if (OidIsValid(att->attcollation))
-					{
-						ObjTree    *collname;
-
-						collname = new_objtree_for_qualname_id(CollationRelationId,
-															   att->attcollation);
-						append_object_object(tmp_obj2, "%{name}D", collname);
-					}
+						insert_collate_object(state, "COLLATE %{name}D",
+											  CollationRelationId, att->attcollation, "name");
 					else
-						append_not_present(tmp_obj2, "%{name}D");
-
-					append_object_object(tmp_obj, "%{collation}s", tmp_obj2);
+						insert_not_present_obj(state, verbose ? "COLLATE %{name}D" : "COLLATE");
 
 					/*
 					 * If there's a USING clause, transformAlterTableStmt ran
 					 * it through transformExpr and stored the resulting node
 					 * in cooked_default, which we can use here.
 					 */
-					tmp_obj2 = new_objtree("USING");
+					insert_jsonb_key(state, "using");
 					if (def->raw_default)
 					{
-						append_string_object(tmp_obj2, "%{expression}s",
-											 "expression", sub->usingexpr);
+						new_jsonb_VA(state, "USING %{expression}s", false, 1,
+									 "expression", jbvString, sub->usingexpr);
 						mark_function_volatile(context, def->cooked_default);
 					}
 					else
-						append_not_present(tmp_obj2, "%{expression}s");
+						insert_not_present_obj(state,
+											   verbose ? "USING %{expression}s" : "USING");
 
-					append_object_object(tmp_obj, "%{using}s", tmp_obj2);
-
-					subcmds = lappend(subcmds, new_object_object(tmp_obj));
+					pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 				}
 				break;
 
-#ifdef TODOLIST
-			case AT_AlterColumnGenericOptions:
-				tmp_obj = deparse_FdwOptions((List *) subcmd->def,
-											subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
-				break;
-#endif
 			case AT_ChangeOwner:
-				tmp_obj = new_objtree_VA("OWNER TO %{owner}I", 2,
-										"type", ObjTypeString, "change owner",
-										"owner", ObjTypeString,
-										get_rolespec_name(subcmd->newowner));
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "OWNER TO %{owner}I", false, 2,
+							 "type", jbvString, "change owner",
+							 "owner", jbvString,
+							 get_rolespec_name(subcmd->newowner));
 				break;
 
 			case AT_ClusterOn:
-				tmp_obj = new_objtree_VA("CLUSTER ON %{index}I", 2,
-										"type", ObjTypeString, "cluster on",
-										"index", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "CLUSTER ON %{index}I", false, 2,
+							 "type", jbvString, "cluster on",
+							 "index", jbvString, subcmd->name);
 				break;
 
+
 			case AT_DropCluster:
-				tmp_obj = new_objtree_VA("SET WITHOUT CLUSTER", 1,
-										"type", ObjTypeString, "set without cluster");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "SET WITHOUT CLUSTER", false, 1,
+							 "type", jbvString, "set without cluster");
 				break;
 
 			case AT_SetLogged:
-				tmp_obj = new_objtree_VA("SET LOGGED", 1,
-										"type", ObjTypeString, "set logged");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "SET LOGGED", false, 1,
+							 "type", jbvString, "set logged");
 				break;
 
 			case AT_SetUnLogged:
-				tmp_obj = new_objtree_VA("SET UNLOGGED", 1,
-										"type", ObjTypeString, "set unlogged");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "SET UNLOGGED", false, 1,
+							 "type", jbvString, "set unlogged");
 				break;
 
 			case AT_DropOids:
-				tmp_obj = new_objtree_VA("SET WITHOUT OIDS", 1,
-										"type", ObjTypeString, "set without oids");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "SET WITHOUT OIDS", false, 1,
+							 "type", jbvString, "set without oids");
 				break;
+
 			case AT_SetAccessMethod:
-				tmp_obj = new_objtree_VA("SET ACCESS METHOD %{access_method}I", 2,
-										"type", ObjTypeString, "set access method",
-										"access_method", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "SET ACCESS METHOD %{access_method}I", false, 2,
+							 "type", jbvString, "set access method",
+							 "access_method", jbvString, subcmd->name);
 				break;
+
 			case AT_SetTableSpace:
-				tmp_obj = new_objtree_VA("SET TABLESPACE %{tablespace}I", 2,
-										"type", ObjTypeString, "set tablespace",
-										"tablespace", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "SET TABLESPACE %{tablespace}I", false, 2,
+							 "type", jbvString, "set tablespace",
+							 "tablespace", jbvString, subcmd->name);
 				break;
 
 			case AT_SetRelOptions:
 			case AT_ResetRelOptions:
-				subcmds = lappend(subcmds, new_object_object(
-															 deparse_RelSetOptions(subcmd)));
+				deparse_RelSetOptions_toJsonb(state, subcmd);
 				break;
 
 			case AT_EnableTrig:
-				tmp_obj = new_objtree_VA("ENABLE TRIGGER %{trigger}I", 2,
-										"type", ObjTypeString, "enable trigger",
-										"trigger", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "ENABLE TRIGGER %{trigger}I", false, 2,
+							 "type", jbvString, "enable trigger",
+							 "trigger", jbvString, subcmd->name);
 				break;
 
 			case AT_EnableAlwaysTrig:
-				tmp_obj = new_objtree_VA("ENABLE ALWAYS TRIGGER %{trigger}I", 2,
-										"type", ObjTypeString, "enable always trigger",
-										"trigger", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "ENABLE ALWAYS TRIGGER %{trigger}I", false, 2,
+							 "type", jbvString, "enable always trigger",
+							 "trigger", jbvString, subcmd->name);
 				break;
 
 			case AT_EnableReplicaTrig:
-				tmp_obj = new_objtree_VA("ENABLE REPLICA TRIGGER %{trigger}I", 2,
-										"type", ObjTypeString, "enable replica trigger",
-										"trigger", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "ENABLE REPLICA TRIGGER %{trigger}I", false, 2,
+							 "type", jbvString, "enable replica trigger",
+							 "trigger", jbvString, subcmd->name);
 				break;
 
 			case AT_DisableTrig:
-				tmp_obj = new_objtree_VA("DISABLE TRIGGER %{trigger}I", 2,
-										"type", ObjTypeString, "disable trigger",
-										"trigger", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "DISABLE TRIGGER %{trigger}I", false, 2,
+							 "type", jbvString, "disable trigger",
+							 "trigger", jbvString, subcmd->name);
 				break;
 
 			case AT_EnableTrigAll:
-				tmp_obj = new_objtree_VA("ENABLE TRIGGER ALL", 1,
-										"type", ObjTypeString, "enable trigger all");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "ENABLE TRIGGER ALL", false, 1,
+							 "type", jbvString, "enable trigger all");
 				break;
 
 			case AT_DisableTrigAll:
-				tmp_obj = new_objtree_VA("DISABLE TRIGGER ALL", 1,
-										"type", ObjTypeString, "disable trigger all");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "DISABLE TRIGGER ALL", false, 1,
+							 "type", jbvString, "disable trigger all");
 				break;
 
 			case AT_EnableTrigUser:
-				tmp_obj = new_objtree_VA("ENABLE TRIGGER USER", 1,
-										"type", ObjTypeString, "enable trigger user");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "ENABLE TRIGGER USER", false, 1,
+							 "type", jbvString, "enable trigger user");
 				break;
 
 			case AT_DisableTrigUser:
-				tmp_obj = new_objtree_VA("DISABLE TRIGGER USER", 1,
-										"type", ObjTypeString, "disable trigger user");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "DISABLE TRIGGER USER", false, 1,
+							 "type", jbvString, "disable trigger user");
 				break;
 
 			case AT_EnableRule:
-				tmp_obj = new_objtree_VA("ENABLE RULE %{rule}I", 2,
-										"type", ObjTypeString, "enable rule",
-										"rule", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "ENABLE RULE %{rule}I", false, 2,
+							 "type", jbvString, "enable rule",
+							 "rule", jbvString, subcmd->name);
 				break;
 
 			case AT_EnableAlwaysRule:
-				tmp_obj = new_objtree_VA("ENABLE ALWAYS RULE %{rule}I", 2,
-										"type", ObjTypeString, "enable always rule",
-										"rule", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "ENABLE ALWAYS RULE %{rule}I", false, 2,
+							 "type", jbvString, "enable always rule",
+							 "rule", jbvString, subcmd->name);
 				break;
 
 			case AT_EnableReplicaRule:
-				tmp_obj = new_objtree_VA("ENABLE REPLICA RULE %{rule}I", 2,
-										"type", ObjTypeString, "enable replica rule",
-										"rule", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "ENABLE REPLICA RULE %{rule}I", false, 2,
+							 "type", jbvString, "enable replica rule",
+							 "rule", jbvString, subcmd->name);
 				break;
 
 			case AT_DisableRule:
-				tmp_obj = new_objtree_VA("DISABLE RULE %{rule}I", 2,
-										"type", ObjTypeString, "disable rule",
-										"rule", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "DISABLE RULE %{rule}I", false, 2,
+							 "type", jbvString, "disable rule",
+							 "rule", jbvString, subcmd->name);
 				break;
 
 			case AT_AddInherit:
-				tmp_obj = new_objtree_VA("INHERIT %{parent}D", 2,
-										"type", ObjTypeString, "inherit",
-										"parent", ObjTypeObject,
-										new_objtree_for_qualname_id(RelationRelationId,
-																	sub->address.objectId));
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+				new_jsonb_VA(state, "INHERIT %{parent}D", true, 1,
+							 "type", jbvString, "inherit");
+				new_jsonb_for_qualname_id(state, RelationRelationId, sub->address.objectId, "parent", false);
+				pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 				break;
 
 			case AT_DropInherit:
-				tmp_obj = new_objtree_VA("NO INHERIT %{parent}D", 2,
-										"type", ObjTypeString, "drop inherit",
-										"parent", ObjTypeObject,
-										new_objtree_for_qualname_id(RelationRelationId,
-																	sub->address.objectId));
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+				new_jsonb_VA(state, "NO INHERIT %{parent}D", true, 1,
+							 "type", jbvString, "drop inherit");
+				new_jsonb_for_qualname_id(state, RelationRelationId, sub->address.objectId, "parent", false);
+				pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 				break;
 
 			case AT_AddOf:
-				tmp_obj = new_objtree_VA("OF %{type_of}T", 2,
-										"type", ObjTypeString, "add of",
-										"type_of", ObjTypeObject,
-										new_objtree_for_type(sub->address.objectId, -1));
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+				new_jsonb_VA(state, "OF %{type_of}T", true, 1,
+							 "type", jbvString, "add of");
+				insert_jsonb_key(state, "type_of");
+				new_jsonb_for_type(state, sub->address.objectId, -1);
+				pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 				break;
 
 			case AT_DropOf:
-				tmp_obj = new_objtree_VA("NOT OF", 1,
-										"type", ObjTypeString, "not of");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "NOT OF", false, 1,
+							 "type", jbvString, "not of");
 				break;
 
 			case AT_ReplicaIdentity:
-				tmp_obj = new_objtree_VA("REPLICA IDENTITY", 1,
-										"type", ObjTypeString, "replica identity");
+				pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+				new_jsonb_VA(state, "REPLICA IDENTITY %{ident}s", true, 1,
+							 "type", jbvString, "replica identity");
 				switch (((ReplicaIdentityStmt *) subcmd->def)->identity_type)
 				{
 					case REPLICA_IDENTITY_DEFAULT:
-						append_string_object(tmp_obj, "%{ident}s", "ident",
-											 "DEFAULT");
+						new_jsonb_VA(state, NULL, true, 1, "ident", jbvString, "DEFAULT");
 						break;
 					case REPLICA_IDENTITY_FULL:
-						append_string_object(tmp_obj, "%{ident}s", "ident",
-											 "FULL");
+						new_jsonb_VA(state, NULL, true, 1, "ident", jbvString, "FULL");
 						break;
 					case REPLICA_IDENTITY_NOTHING:
-						append_string_object(tmp_obj, "%{ident}s", "ident",
-											 "NOTHING");
+						new_jsonb_VA(state, NULL, true, 1, "ident", jbvString, "NOTHING");
 						break;
 					case REPLICA_IDENTITY_INDEX:
-						tmp_obj2 = new_objtree_VA("USING INDEX %{index}I", 1,
-												 "index", ObjTypeString,
-												 ((ReplicaIdentityStmt *) subcmd->def)->name);
-						append_object_object(tmp_obj, "%{ident}s", tmp_obj2);
+						insert_jsonb_key(state, "ident");
+						new_jsonb_VA(state, "USING INDEX %{index}I", false, 1,
+									 "index", jbvString,
+									 ((ReplicaIdentityStmt *) subcmd->def)->name);
 						break;
 				}
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 				break;
 
 			case AT_EnableRowSecurity:
-				tmp_obj = new_objtree_VA("ENABLE ROW LEVEL SECURITY", 1,
-										"type", ObjTypeString, "enable row security");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "ENABLE ROW LEVEL SECURITY", false, 1,
+							 "type", jbvString, "enable row security");
 				break;
 
 			case AT_DisableRowSecurity:
-				tmp_obj = new_objtree_VA("DISABLE ROW LEVEL SECURITY", 1,
-										"type", ObjTypeString, "disable row security");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "DISABLE ROW LEVEL SECURITY", false, 1,
+							 "type", jbvString, "disable row security");
 				break;
-#ifdef TODOLIST
-			case AT_GenericOptions:
-				tmp_obj = deparse_FdwOptions((List *) subcmd->def, NULL);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
-				break;
-#endif
+
 			case AT_AttachPartition:
-				tmp_obj = new_objtree_VA("ATTACH PARTITION %{partition_identity}D",
-										2, "type", ObjTypeString, "attach partition",
-										"partition_identity", ObjTypeObject,
-										new_objtree_for_qualname_id(RelationRelationId,
-																	sub->address.objectId));
+				pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+				new_jsonb_VA(state, "ATTACH PARTITION %{partition_identity}D %{partition_bound}s", true,
+							 1, "type", jbvString, "attach partition");
+				new_jsonb_for_qualname_id(state, RelationRelationId, sub->address.objectId, "partition_identity", false);
 
-				tmp_obj2 = new_objtree("");
 				if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
-					append_string_object(tmp_obj, "%{partition_bound}s",
-										 "partition_bound",
-										 RelationGetPartitionBound(sub->address.objectId));
+					new_jsonb_VA(state, NULL, true, 1, "partition_bound", jbvString, RelationGetPartitionBound(sub->address.objectId));
 				else
-					append_not_present(tmp_obj2, "%{partition_bound}s");
+					new_jsonb_VA(state, NULL, true, 1, "partition_bound", jbvString, "");
 
-				append_object_object(tmp_obj, "%{partition_bound}s", tmp_obj2);
+				pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
 				break;
 			case AT_DetachPartition:
-			{
-				PartitionCmd *cmd;
-
-				Assert(IsA(subcmd->def, PartitionCmd));
-				cmd = (PartitionCmd *) subcmd->def;
-
-				tmp_obj = new_objtree_VA("DETACH PARTITION %{partition_identity}D %{concurrent}s", 3,
-										"type", ObjTypeString,
-										"detach partition",
-										"partition_identity", ObjTypeObject,
-										new_objtree_for_qualname_id(RelationRelationId,
-																	sub->address.objectId),
-										"concurrent", ObjTypeString,
-										cmd->concurrent ? "CONCURRENTLY" : "");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
-				break;
-			}
+				{
+					PartitionCmd *cmd;
+
+					Assert(IsA(subcmd->def, PartitionCmd));
+					cmd = (PartitionCmd *) subcmd->def;
+
+					pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+					new_jsonb_VA(state, "DETACH PARTITION %{partition_identity}D %{concurrent}s", true, 2,
+								 "type", jbvString, "detach partition",
+								 "concurrent", jbvString,
+								 cmd->concurrent ? "CONCURRENTLY" : "");
+					new_jsonb_for_qualname_id(state, RelationRelationId, sub->address.objectId, "partition_identity", false);
+					pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+					break;
+				}
 			case AT_DetachPartitionFinalize:
-				tmp_obj = new_objtree_VA("DETACH PARTITION %{partition_identity}D FINALIZE", 2,
-										"type", ObjTypeString, "detach partition finalize",
-										"partition_identity", ObjTypeObject,
-										new_objtree_for_qualname_id(RelationRelationId,
-																	sub->address.objectId));
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+				new_jsonb_VA(state, "DETACH PARTITION %{partition_identity}D FINALIZE", true, 1,
+							 "type", jbvString, "detach partition finalize");
+
+				new_jsonb_for_qualname_id(state, RelationRelationId, sub->address.objectId, "partition_identity", false);
+				pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 				break;
 			case AT_AddIdentity:
 				{
 					AttrNumber	attnum;
 					Oid			seq_relid;
-					ObjTree    *seqdef;
 					ColumnDef  *coldef = (ColumnDef *) subcmd->def;
 
-					tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I", 2,
-											"type", ObjTypeString, "add identity",
-											"column", ObjTypeString, subcmd->name);
+					pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+					new_jsonb_VA(state, "ALTER COLUMN %{column}I %{definition}s", true, 2,
+								 "type", jbvString, "add identity",
+								 "column", jbvString, subcmd->name);
 
 					attnum = get_attnum(RelationGetRelid(rel), subcmd->name);
 					seq_relid = getIdentitySequence(RelationGetRelid(rel), attnum, true);
 
-					tmp_obj2 = new_objtree("ADD");
+					insert_jsonb_key(state, "definition");
 					if (OidIsValid(seq_relid))
 					{
-						seqdef = deparse_ColumnIdentity(seq_relid, coldef->identity, false);
-						append_object_object(tmp_obj2, "%{identity_column}s", seqdef);
+						/* insert definition's value now */
+						pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+						fmt_to_jsonb_element(state, "ADD %{identity_column}s");
+
+						/* insert identity_column as key */
+						insert_jsonb_key(state, "identity_column");
+
+						/* insert identity_column's value */
+						deparse_ColumnIdentity_toJsonb(state, seq_relid, coldef->identity, false);
+
+						/* mark definition's value end */
+						pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 					}
 					else
-						append_not_present(tmp_obj2, "%{identity_column}s");
+						insert_not_present_obj(state, verbose ? "ADD %{identity_column}s" : "ADD");
 
-					append_object_object(tmp_obj, "%{definition}s", tmp_obj2);
-
-					subcmds = lappend(subcmds, new_object_object(tmp_obj));
+					pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 				}
 				break;
 			case AT_SetIdentity:
 				{
 					DefElem    *defel;
 					char		identity = 0;
-					ObjTree    *seqdef;
 					AttrNumber	attnum;
 					Oid			seq_relid;
 
-
-					tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I", 2,
-											"type", ObjTypeString, "set identity",
-											"column", ObjTypeString, subcmd->name);
+					pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+					new_jsonb_VA(state, "ALTER COLUMN %{column}I %{definition}s", true, 2,
+								 "type", jbvString, "set identity",
+								 "column", jbvString, subcmd->name);
 
 					if (subcmd->def)
 					{
@@ -2810,31 +2699,26 @@ deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
 					attnum = get_attnum(RelationGetRelid(rel), subcmd->name);
 					seq_relid = getIdentitySequence(RelationGetRelid(rel), attnum, true);
 
-					tmp_obj2 = new_objtree("");
+					insert_jsonb_key(state, "definition");
 					if (OidIsValid(seq_relid))
 					{
-						seqdef = deparse_ColumnIdentity(seq_relid, identity, true);
-						append_object_object(tmp_obj2, "%{definition}s", seqdef);
+						deparse_ColumnIdentity_toJsonb(state, seq_relid, identity, true);
 					}
 					else
-						append_not_present(tmp_obj2, "%{definition}s");
+						insert_not_present_obj(state, verbose ? "%{definition}s" : "");
 
-					append_object_object(tmp_obj, "%{definition}s", tmp_obj2);
+					pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 
-					subcmds = lappend(subcmds, new_object_object(tmp_obj));
 					break;
 				}
 			case AT_DropIdentity:
-				tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I DROP IDENTITY", 2,
-										"type", ObjTypeString, "drop identity",
-										"column", ObjTypeString, subcmd->name);
-
-				append_string_object(tmp_obj, "%{if_exists}s",
-									 "if_exists",
-									 subcmd->missing_ok ? "IF EXISTS" : "");
-
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
-				break;
+				{
+					new_jsonb_VA(state, "ALTER COLUMN %{column}I DROP IDENTITY %{if_exists}s", false, 3,
+								 "type", jbvString, "drop identity",
+								 "column", jbvString, subcmd->name,
+								 "if_exists", jbvString, subcmd->missing_ok ? "IF EXISTS" : "");
+					break;
+				}
 			default:
 				elog(WARNING, "unsupported alter table subtype %d",
 					 subcmd->subtype);
@@ -2844,124 +2728,105 @@ deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
 
 	table_close(rel, AccessShareLock);
 
-	if (list_length(subcmds) == 0)
+	/* sub commands not found, return NULL */
+	if (!subCmdArray)
 		return NULL;
 
-	append_array_object(ret, "%{subcmds:, }s", subcmds);
-
-	return ret;
-}
-
-/*
- * Handle deparsing of DROP commands.
- *
- * Verbose syntax
- * DROP %{objtype}s %{concurrently}s %{if_exists}s %{objidentity}s %{cascade}s
- */
-char *
-deparse_drop_command(const char *objidentity, const char *objecttype,
-					 Node *parsetree)
-{
-	DropStmt   *node = (DropStmt *) parsetree;
-	StringInfoData str;
-	char	   *command;
-	char	   *identity = (char *) objidentity;
-	ObjTree    *stmt;
-	ObjTree    *tmp_obj;
-	Jsonb	   *jsonb;
-
-	initStringInfo(&str);
+	pushJsonbValue(&state, WJB_END_ARRAY, NULL);
+	appendStringInfoString(&fmtStr, "%{subcmds:, }s");
 
-	stmt = new_objtree_VA("DROP %{objtype}s %{concurrently}s %{if_exists}s %{objidentity}s", 4,
-						  "objtype", ObjTypeString, objecttype,
-						  "concurrently", ObjTypeString,
-						  node->concurrent ? "CONCURRENTLY" : "",
-						  "if_exists", ObjTypeString,
-						  node->missing_ok ? "IF EXISTS" : "",
-						  "objidentity", ObjTypeString, identity);
+	/* We have full fmt by now, so add jsonb element for that */
+	fmt_to_jsonb_element(state, fmtStr.data);
 
-	tmp_obj = new_objtree("CASCADE");
-	if (node->behavior != DROP_CASCADE)
-		append_not_present(tmp_obj, NULL);
-	append_object_object(stmt, "%{cascade}s", tmp_obj);
+	pfree(fmtStr.data);
 
-	jsonb = objtree_to_jsonb(stmt, NULL /* Owner/role can be skipped for drop command */);
-	command = JsonbToCString(&str, &jsonb->root, JSONB_ESTIMATED_LEN);
+	/* Mark the end of ROOT object */
+	value = pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 
-	return command;
+	return JsonbValueToJsonb(value);
 }
 
 /*
- * Deparse an AlterObjectSchemaStmt (ALTER ... SET SCHEMA command)
+ * Deparse a CreateSeqStmt.
  *
- * Given the object address and the parse tree that created it, return an
- * ObjTree representing the alter command.
+ * Given a sequence OID and the parse tree that created it, return Jsonb
+ * representing the creation command.
+ *
+ * Note: We need to deparse the CREATE SEQUENCE command for the TABLE
+ * commands. For example, When creating a table, if we specify a column as a
+ * sequence type, then we will create a sequence for that column and set that
+ * sequence OWNED BY the table.
  *
  * Verbose syntax
- * ALTER %{objtype}s %{identity}s SET SCHEMA %{newschema}I
+ * CREATE %{persistence}s SEQUENCE %{identity}D %{definition: }s
  */
-static ObjTree *
-deparse_AlterObjectSchemaStmt(ObjectAddress address, Node *parsetree,
-							  ObjectAddress old_schema)
+static Jsonb *
+deparse_CreateSeqStmt(Oid objectId, Node *parsetree, char *owner)
 {
-	AlterObjectSchemaStmt *node = (AlterObjectSchemaStmt *) parsetree;
-	char	   *identity;
-	char	   *new_schema = node->newschema;
-	char	   *old_schname;
-	char	   *ident;
+	Relation	relation;
+	Form_pg_sequence seqform;
+	Sequence_values *seqvalues;
+	CreateSeqStmt *createSeqStmt = (CreateSeqStmt *) parsetree;
+	JsonbParseState *state = NULL;
+	JsonbValue *value;
 
 	/*
-	 * Since the command has already taken place from the point of view of
-	 * catalogs, getObjectIdentity returns the object name with the already
-	 * changed schema.  The output of our deparsing must return the original
-	 * schema name, however, so we chop the schema name off the identity
-	 * string and then prepend the quoted schema name.
-	 *
-	 * XXX This is pretty clunky. Can we do better?
+	 * Only support sequence for IDENTITY COLUMN output separately (via CREATE
+	 * TABLE or ALTER TABLE). Otherwise, return empty here.
 	 */
-	identity = getObjectIdentity(&address, false);
-	old_schname = get_namespace_name(old_schema.objectId);
-	if (!old_schname)
-		elog(ERROR, "cache lookup failed for schema with OID %u",
-			 old_schema.objectId);
+	if (createSeqStmt->for_identity)
+		return NULL;
 
-	ident = psprintf("%s%s", quote_identifier(old_schname),
-					 identity + strlen(quote_identifier(new_schema)));
+	relation = relation_open(objectId, AccessShareLock);
 
-	return new_objtree_VA("ALTER %{objtype}s %{identity}s SET SCHEMA %{newschema}I", 3,
-						  "objtype", ObjTypeString,
-						  stringify_objtype(node->objectType, false),
-						  "identity", ObjTypeString, ident,
-						  "newschema", ObjTypeString, new_schema);
-}
+	/* mark the start of ROOT object */
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
 
-/*
- * Deparse an AlterOwnerStmt (ALTER ... OWNER TO ...).
- *
- * Given the object address and the parse tree that created it, return an
- * ObjTree representing the alter command.
- *
- * Verbose syntax
- * ALTER %{objtype}s %{identity}s OWNER TO %{newowner}I
- */
-static ObjTree *
-deparse_AlterOwnerStmt(ObjectAddress address, Node *parsetree)
-{
-	AlterOwnerStmt *node = (AlterOwnerStmt *) parsetree;
+	/* create owner jsonb element */
+	role_to_jsonb_element(state, owner);
+
+	new_jsonb_VA(state, "CREATE %{persistence}s SEQUENCE %{if_not_exists}s %{identity}D %{definition: }s", true, 2,
+				 "persistence", jbvString,
+				 get_persistence_str(relation->rd_rel->relpersistence),
+				 "if_not_exists", jbvString,
+				 createSeqStmt->if_not_exists ? "IF NOT EXISTS" : "");
+
+	insert_identity_object(state, relation->rd_rel->relnamespace,
+						   RelationGetRelationName(relation));
+	relation_close(relation, AccessShareLock);
+
+	seqvalues = get_sequence_values(objectId);
+	seqform = seqvalues->seqform;
+
+	/* sequence definition array object creation, push the key first */
+	insert_jsonb_key(state, "definition");
+
+	pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
 
-	return new_objtree_VA("ALTER %{objtype}s %{identity}s OWNER TO %{newowner}I", 3,
-						  "objtype", ObjTypeString,
-						  stringify_objtype(node->objectType, false),
-						  "identity", ObjTypeString,
-						  getObjectIdentity(&address, false),
-						  "newowner", ObjTypeString,
-						  get_rolespec_name(node->newowner));
+	/* Definition elements */
+	deparse_Seq_Cache_toJsonb(state, seqform, false);
+	deparse_Seq_Cycle_toJsonb(state, seqform, false);
+	deparse_Seq_IncrementBy_toJsonb(state, seqform, false);
+	deparse_Seq_Minvalue_toJsonb(state, seqform, false);
+	deparse_Seq_Maxvalue_toJsonb(state, seqform, false);
+	deparse_Seq_Startwith_toJsonb(state, seqform, false);
+	deparse_Seq_Restart_toJsonb(state, seqvalues->last_value);
+	deparse_Seq_As_toJsonb(state, seqform);
+	/* We purposefully do not emit OWNED BY here */
+
+	/* mark the end of sequence definition array */
+	pushJsonbValue(&state, WJB_END_ARRAY, NULL);
+
+	/* mark the end of ROOT object */
+	value = pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+
+	return JsonbValueToJsonb(value);
 }
 
 /*
  * Deparse an AlterSeqStmt.
  *
- * Given a sequence OID and a parse tree that modified it, return an ObjTree
+ * Given a sequence OID and a parse tree that modified it, return Jsonb
  * representing the alter command.
  *
  * Note: We need to deparse the ALTER SEQUENCE command for the TABLE commands.
@@ -2972,16 +2837,16 @@ deparse_AlterOwnerStmt(ObjectAddress address, Node *parsetree)
  * Verbose syntax
  * ALTER SEQUENCE %{identity}D %{definition: }s
  */
-static ObjTree *
-deparse_AlterSeqStmt(Oid objectId, Node *parsetree)
+static Jsonb *
+deparse_AlterSeqStmt(Oid objectId, Node *parsetree, char *owner)
 {
-	ObjTree    *ret;
 	Relation	relation;
-	List	   *elems = NIL;
 	ListCell   *cell;
 	Form_pg_sequence seqform;
 	Sequence_values *seqvalues;
 	AlterSeqStmt *alterSeqStmt = (AlterSeqStmt *) parsetree;
+	JsonbParseState *state = NULL;
+	JsonbValue *value;
 
 	/*
 	 * Sequence for IDENTITY COLUMN output separately (via CREATE TABLE or
